﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.Windows.Data;
using System.Linq;
using System.Collections.Generic;

namespace _2010_12_02_XamGridComboEditor
{


    public class StateHelper
    {
        static StatesTest _list = new StatesTest();


        static public StatesTest GetStates()
        {
            return _list;
        }

    }



    public class StatesTest : ObservableCollection<StateTest>
    {
        public StatesTest()
        {
            base.Add(new StateTest(1, "TX"));
            base.Add(new StateTest(2, "WA"));
            base.Add(new StateTest(3, "CO"));
        }
    }

    public class StateTest
    {
        int _st_Id;
        string _st_Code;

        public StateTest(int id, string code)
        {
            _st_Id = id;
            _st_Code = code;
        }

        public int St_Id
        {
            get { return _st_Id; }
            set { _st_Id = value; }
        }

        public string St_Code
        {
            get { return _st_Code; }
            set { _st_Code = value; }
        }
    }


    public class StateComboBindingToTextConverter : IValueConverter
    {

        private ObservableCollection<StateTest> States;
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value == null) { return null; }
            int inVal = (int)value;
            States = (ObservableCollection<StateTest>)parameter;
            return GetStateTestByID(inVal).St_Code;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            //string result = null;

            if (value != null)
            {
                return value.ToString();
            }
            return null;

            //StateTest selectedType = value as StateTest;
            //if (selectedType != null)
            //{
            //    result = selectedType.St_Code;
            //}
            //return result;
        }

        private StateTest GetStateTestByID(int id)
        {
            return States.FirstOrDefault(b => b.St_Id == id);
        }
    }


    public class StateComboBindingToIntegerConverter : IValueConverter
    {

        private ObservableCollection<StateTest> States;
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value == null) { return null; }
            int inVal = (int)value;
            States = (ObservableCollection<StateTest>)parameter;
            //return GetStateTestByID(inVal).St_Id;
            return GetStateTestByID(inVal);
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {

       
            //if (value != null)
            //{
            //    return (int)value;
            //}
            //return null;


            //int? result = null;
            StateTest selectedType = value as StateTest;
            if (selectedType != null)
            {
                return selectedType.St_Id;
            }
            return value;
        }

        private StateTest GetStateTestByID(int id)
        {
            return States.FirstOrDefault(b => b.St_Id == id);
        }
    }




}
